#!/usr/bin/env -S php -q

<?php

/*
Copyright 2013 Bing Technologies Pty Lid. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE BING TECHNOLOGIES PTY.LTD.  "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL BING TECHNOLOGIES PTY. LTD. BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are
those of the authors and should not be interpreted as representing official
policies, either expressed or implied, of Bing Technologies Pty. Ltd.
*/

require(__DIR__ . '/easypost_api.php');

$obj = new ep_uploader();

#$obj->load_config_ini(__DIR__ . '/ep_api.ini');
$obj->load_config_php(__DIR__ . '/ep_api_conf.php');

// an array that is going to become eventually a json array
$letters = array(
	"duplex" => true,
	"colour_model" => 'colour',
	"orientation" => 'portrait',
	'letters' => array(
		array(
			"postal" => array(
				"Mr John Smith",
				"28 Harries Rd",
				"COORPAROO QLD 4151"
			)
		),
		array(
			"postal" => array(
				"T F Eccles",
				"29 Harries Rd",
				"COORPAROO QLD 4151"
			)
		),
		array(
            "fax" => "8888888"
		),
		array(
			"email" => "dave@somedomain.com.au" 
		)
	),
	"cust_hold" => true
);

$jsonfname = $obj->make_json_file($letters);

$FILENAMES =  array(array($jsonfname, 'meta_example.json'), 'example.pdf');

try {
	$reply = $obj->do_upload($FILENAMES);

	var_dump($reply);

	echo "id: ".$reply['session_id']."\n";
	echo "Files: \n";
	foreach( $reply['files'] as $fname) {
		echo"\t". $fname['name']."\n";
	}
} catch( Exception $e) {
	echo "Error:\n";
	switch( $e->getCode() ) {
		case 401:
			echo "Wrong login and/or password\n";
			break;
		case 403:
			echo "Wrong account\n";
			break;
		default:
			echo $e->getMessage();
			if ( $e->getCode() != 0 ) {
				echo ' Error code: '.$e->getCode()."\n";
			}
			break;
	}
	
}

unlink($jsonfname);

?>
